/********     
 * test for dma read/write
 **************/

#include <sys/types.h>
#include <sys/errno.h>
#include <sys/mman.h>
#include <unistd.h>
#include <fcntl.h>
#include <malloc.h>
#include <sys/ioctl.h>
#include <c_asm.h>
#include <mach/alpha/boolean.h>
#include <io/common/devdriver.h>  /* Defines HANDLE_LONGWORD */
#include <io/common/handler.h>    /* For use with vbareg.h */
#include <io/dec/vme/vbareg.h>    /* Defined VME_A24, VME_DENSE, etc. */
#include "/sys/io/lh/lhdriver.h"
#include "readpcc.h"
#define BUF_SIZE (size_t)(8*1024)

main()
{ 
	int *write_buffer;
	int *read_buffer;
	int *wptr,*rptr;
	struct dma_info set_lhdma;
	int fd,i,stat;
	int err = 0;
	long start,end;
	/* lock the memory */
	if( (stat = mlockall( MCL_CURRENT | MCL_FUTURE ))<0){
		perror("mlock");
	}
	/* allocate 128 K Bytes buffer */
/*	wptr = (int *)malloc(BUF_SIZE);
	write_buffer = wptr;
	if(!(write_buffer))
	{
	perror("write malloc");
	exit(1);
	}
*/
	rptr = (int *)malloc(BUF_SIZE);
	read_buffer = rptr;
	if (!(read_buffer))
	{
	perror("read malloc");
	exit(1);
	}

	/*fill data*/
/*	for(i=0;i<BUF_SIZE/4;i++){
		*write_buffer=i;
		write_buffer++;
	}
	write_buffer = wptr;

	 for(i=0;i<BUF_SIZE/4;i++){
		if( *write_buffer != i ){
			printf("not right i=%d\n",i);
			printf("write_data =%d\n",write_buffer);
			free( wptr );
			exit(1);
		}
		write_buffer++;
	}
	write_buffer = wptr;
*/
	for(i=0;i<BUF_SIZE/4;i++){
		*read_buffer=0;
		read_buffer++;
	}
	read_buffer = rptr;
	for(i=0;i<BUF_SIZE/4;i++){
		if( *read_buffer != 0 ){
			printf("not right i=%d\n",i);
			printf("read_data =%d\n",read_buffer);
			free( rptr );
			exit(1);
		}
		read_buffer++;
	}
	read_buffer = rptr;

	/* set DMA write info */
	if ((fd = open("/dev/lh",O_RDWR)) < 0)
    	{
    	perror("Error opening lh0");
    	exit(1);
    	}
/*
	set_lhdma.flag = (vme_atype_t)( DMA_OUT 
			| VME_A32 | DMA_SLEEP | VME_UDATA 
                        | VME_D32 ) ;
	set_lhdma.vmeaddr = (vme_addr_t)0x0800000;
	if ((err = ioctl(fd, LH_SET_DMA_INFO, &set_lhdma)) < 0)
    	{
    	perror("LH_SET_DMA_INFO");
    	close(fd);
   	exit(1);
    	}
*/

	/* Strat Write Data */
/*	readpcc(start);
	if ((err=write(fd,write_buffer,BUF_SIZE))< 0)
    	{
    	perror("Block_write1");
    	close(fd);
    	exit(1);
    	}
	readpcc(end);
*/

	/* Clean Up */
/*	if ((err = ioctl(fd, LH_UNSET_DMA_INFO )) < 0)
    	{
    	perror("LH_UNSET_DMA_INFO");
    	close(fd);
    	exit(1);
    	}
*/

	/* set DMA read info */
	set_lhdma.flag = (vme_atype_t)( DMA_IN 
			| VME_A32 | DMA_SLEEP | VME_UDATA 
                        | VME_D64 ) ;
	set_lhdma.vmeaddr = (vme_addr_t)0x0800000;
	if ((err = ioctl(fd, LH_SET_DMA_INFO, &set_lhdma)) < 0)
    	{
    	perror("LH_SET_DMA_INFO");
    	close(fd);
   	exit(1);
    	}


	/* Read Data */
	readpcc(start);
	if ((err=read(fd,read_buffer,BUF_SIZE))< 0)
    	{
    	perror("Block_write1");
    	close(fd);
    	exit(1);
    	}
	readpcc(end);
	printf("DMA read %ld cycle\n",(end-start) ); 

	/* Clean Up */
	if ((err = ioctl(fd, LH_UNSET_DMA_INFO )) < 0)
    	{
    	perror("LH_UNSET_DMA_INFO");
    	close(fd);
    	exit(1);
	}

	/* Compare data */
/*
	 for(i=0;i<BUF_SIZE/4;i++){
		if( *write_buffer != *read_buffer ){
			printf("data not right i=%d\n",i);
			printf("write_data =%d\n",write_buffer);
			printf("read_data =%d\n",read_buffer);
			free( write_buffer );
			free( read_buffer );
			exit(1);
			write_buffer++;
			read_buffer++;
		}
	}
*/
	printf("data right\n");
/*
	free( wptr );
*/
	free( rptr );
	close(fd);
	munlockall();
	exit(0);

}


