/*
 * *****************************************************************
 * *                                                               *
 * *    Copyright (c) Digital Equipment Corporation, 1991, 1994    *
 * *                                                               *
 * *   All Rights Reserved.  Unpublished rights  reserved  under   *
 * *   the copyright laws of the United States.                    *
 * *                                                               *
 * *   The software contained on this media  is  proprietary  to   *
 * *   and  embodies  the  confidential  technology  of  Digital   *
 * *   Equipment Corporation.  Possession, use,  duplication  or   *
 * *   dissemination of the software and media is authorized only  *
 * *   pursuant to a valid written license from Digital Equipment  *
 * *   Corporation.                                                *
 * *                                                               *
 * *   RESTRICTED RIGHTS LEGEND   Use, duplication, or disclosure  *
 * *   by the U.S. Government is subject to restrictions  as  set  *
 * *   forth in Subparagraph (c)(1)(ii)  of  DFARS  252.227-7013,  *
 * *   or  in  FAR 52.227-19, as applicable.                       *
 * *                                                               *
 * *****************************************************************
 */
/*
 * HISTORY
 */
/*
 * @(#)$RCSfile: lhdriver.h,v $ $Revision: 1.1.2.2 $ (DEC) $Date: 1994/11/10 22:06:43 $
 */
#include <io/dec/vme/vbareg.h>
/* lh_data structure definition to pass into ioctl for function
 * LH_MAP_PIO_ADDR and LH_GET_PIO_INFO.
 */
struct pio_info {
    unsigned int pio_addr; /* VME address to map outbound to */
    unsigned int pio_size; /* Size to map outbound to */
    unsigned int pio_am;   /* Address modifier for pio_addr */
    unsigned int pio_access; /* Access type */
    };

struct dma_info {
    vme_atype_t flag;		   /*vme mode: only A32 or A64*/
    vme_addr_t  vmeaddr;
};

/* ioctl defines 
 * LH_MAP_PIO_ADDR maps outbound to a VME address.
 * LH_UNMAP_PIO_ADDR unmaps the outbound mapping.
 * LH_GET_PIO_INFO returns information about the outbound mapping.
 */
#define DMA	2
#define NON_DMA 1
#define LH_MAP_PIO_ADDR   _IOW( 5, 4, struct pio_info)
#define LH_SET_DMA_INFO   _IOW( 5, 5, struct dma_info)
#define LH_UNSET_DMA_INFO _IO( 5, 6 )
#define LH_UNMAP_PIO_ADDR _IOW( 5 ,7, int)
#define LH_GET_PIO_INFO   _IOR( 5 ,8, struct pio_info)

