/* File name     : vmelib.h
 * Creation date : August 1995
 * Author        : Y.Yasu, Online group, Physics department, KEK
 */

#define VME_A16D16SIZE     0x7000
#define VME_A16D32SIZE     0x4000
#define VME_A24D16SIZE   0x400000
#define VME_A24D32SIZE   0x400000
#define VME_A32D16SIZE   0x800000
#define VME_A32D32SIZE   0x800000

#define VME_A16D16BASE     0x8000
#define VME_A16D32BASE     0x4000
#define VME_A24D16BASE   0x800000
#define VME_A24D32BASE   0xC00000
#define VME_A32D16BASE 0x80000000
#define VME_A32D32BASE 0xC0000000

#define VMEIOC_INIT       _IOWR('v',1,int)
#define VMEIOC_OPEN       _IOWR('v',2,struct vmecmd)
#define VMEIOC_CLOSE      _IOWR('v',3,int)
#define VMEIOC_ENABLE     _IOWR('v',4,int)
#define VMEIOC_DISABLE    _IOWR('v',5,int)
#define VMEIOC_WAIT       _IOWR('v',6,struct vmecmd)
#define VMEIOC_NOWAIT     _IOWR('v',7,struct vmecmd)
#define VMEIOC_CLEAR      _IOWR('v',8,int)
#define VMEIOC_CHECK      _IOWR('v',9,struct vmecmd)

struct vmecmd {
    int intrno;
    int data;
    int reply[2];
};

#define VME_A16D16MODE 1
#define VME_A16D32MODE 2
#define VME_A24D16MODE 3
#define VME_A32D32MODE 4
#define VME_A32D16MODE 5
#define VME_A24D32MODE 6
