/* File name     : vmelib.c
 * Creation date : May 1993
 * Author        : Y.Yasu, Online group, Physics department, KEK
 */

#define DEBUG
#include	<stdio.h>
#include	<fcntl.h>
#include	<sys/types.h>
#include	<sys/file.h>
#include	<sys/mman.h>
#include        <sys/ioctl.h>
#include        <sys/errno.h>
#include        "vmelib.h"

extern	int	errno;
static struct vmecmd vmecmd;
static int vme_path;

int vme_intopen( vector, intrno )
int vector;
int *intrno; {
    if ((vme_path = open("/dev/int", O_RDWR)) == -1)
        return errno;
    printf("vme_intopen: open ok\n");
    vmecmd.intrno = vector;
    printf("vme_intopen: vector num = %x\n", vector);
    if( (ioctl(vme_path, VMEIOC_OPEN, &vmecmd )) == -1 )
        return errno;
    *intrno = vmecmd.data;
    return 0;
}

int vme_intclose( intrno )
int intrno; {
    vmecmd.intrno = intrno;
    if( ( ioctl( vme_path, VMEIOC_CLOSE, &intrno ) ) == -1 )
        return errno;
    return 0;
}


int vme_intenable( intrno )
int intrno; {
    int intrno1 = intrno;

    if( ( ioctl( vme_path, VMEIOC_ENABLE, &intrno1 ) ) == -1 )
        return errno;
    return 0;
}

int vme_intdisable( intrno )
int intrno; {
    if( ( ioctl( vme_path, VMEIOC_DISABLE, &intrno ) ) == -1 )
        return errno;
    return 0;
}

int vme_intwait( intrno, interrupt_count, timeout )
int intrno, *interrupt_count, timeout; {

    vmecmd.intrno = intrno;
    vmecmd.data = timeout;
    ioctl( vme_path, VMEIOC_WAIT, &vmecmd );
#ifdef DEBUG
    printf("status block [0] = %d\n", vmecmd.reply[0]);
    printf("status block [1] = %d\n", vmecmd.reply[1]);
#endif
    *interrupt_count = vmecmd.reply[0];
    if( errno == EINTR && vmecmd.reply[1] == -1 )
        return ETIMEDOUT;
    if( errno == EINTR && vmecmd.reply[1] == -2 )
        return errno;
    if( errno == EINTR && vmecmd.reply[1] == 0 )
        return 0;
    return errno;
}

int vme_intnowait( intrno, interrupt_count )
int intrno, *interrupt_count; {

    vmecmd.intrno = intrno;
    ioctl( vme_path, VMEIOC_NOWAIT, &vmecmd );
#ifdef DEBUG
    printf("status block [0] = %d\n", vmecmd.reply[0]);
    printf("status block [1] = %d\n", vmecmd.reply[1]);
#endif
    *interrupt_count = vmecmd.reply[0];
    if( errno == EINTR && vmecmd.reply[1] == 0 )
        return 0;
    return errno;
}

int vme_intclear( intrno )
int intrno; {
   if( ( ioctl( vme_path, VMEIOC_CLEAR, &intrno ) ) == -1 )
        return errno;
}

int vme_intcheck( intrno, interrupt_count )
int intrno, *interrupt_count; {

    vmecmd.intrno = intrno;
    ioctl(vme_path, VMEIOC_CHECK, &vmecmd );
#ifdef DEBUG
    printf("status block [0] = %d\n", vmecmd.reply[0]);
    printf("status block [1] = %d\n", vmecmd.reply[1]);
#endif
    *interrupt_count = vmecmd.reply[0];
    if( errno == EINTR && vmecmd.reply[1] == 0 )
        return 0;
    return errno;
}




